from stats_collector.stats import Statistics
from stats_collector import FRED_DB
from stats_collector.stats.stat_registry import stat_registry
from ..groups import FRED_DAILY_GROUP


@stat_registry.register(FRED_DAILY_GROUP)
class LinkedObjects(Statistics):
    sql = '''
        SELECT
            CASE
                WHEN oreg.type = 1 then 'contact'
                WHEN oreg.type = 2 then 'nsset'
                WHEN oreg.type = 4 then 'keyset'
            END,
            COUNT(*)
          FROM
            enum_object_states eos
            JOIN object_state os ON os.state_id = eos.id
            JOIN object_registry oreg ON oreg.id = os.object_id
          WHERE
            eos.name = 'linked'
            AND os.valid_from < %(midnight)s
                AND (os.valid_to IS NULL OR os.valid_to >= %(midnight)s)
            AND oreg.type IN (1,2,4)
          GROUP BY 1
    '''
    name = 'linked_objects'
    stat_db = FRED_DB

