from stats_collector.stats import Statistics
from stats_collector import FRED_DB
from stats_collector.stats.stat_registry import stat_registry
from ..groups import FRED_DAILY_GROUP


@stat_registry.register(FRED_DAILY_GROUP)
class NumberOfDomains(Statistics):
    sql = '''
        SELECT COUNT(*)
        FROM
            object_registry O
            JOIN domain_history D ON (D.historyid = O.crhistoryid)
            JOIN zone Z ON (D.zone = Z.id)
        WHERE type = 3
            AND (crdate < %(midnight)s AND (erdate IS NULL OR erdate >= %(midnight)s))
            AND name NOT LIKE '%(monitoring_domain)s'
            AND Z.fqdn = 'cz'
    '''
    name = 'number_of_domains'
    stat_db = FRED_DB

