from stats_collector.stats import Statistics
from stats_collector import LOG_DB
from stats_collector.stats.stat_registry import stat_registry
from ..groups import FRED_DAILY_GROUP


@stat_registry.register(FRED_DAILY_GROUP)
class OperationsInRegistryByRegistrar(Statistics):
    sql = '''
        SELECT
            r.user_name,
            CASE
               WHEN r.request_type_id = 506 THEN 'domain_renew'
               WHEN r.request_type_id = 504 THEN 'domain_create'
               WHEN r.request_type_id = 204 THEN 'contact_create'
               WHEN r.request_type_id = 404 THEN 'nsset_create'
               WHEN r.request_type_id = 503 THEN 'domain_update'
               WHEN r.request_type_id = 203 THEN 'contact_update'
               WHEN r.request_type_id = 403 THEN 'nsset_update'
               WHEN r.request_type_id = 505 THEN 'domain_transfer'
            END,
            COUNT(*)
        FROM request r
             JOIN result_code rc ON r.result_code_id = rc.id
        WHERE
            %(log_req_cond_epp)s
            AND r.request_type_id in (506, 504, 204, 404, 503, 203, 403, 505)
            AND rc.result_code = 1000
        GROUP BY 1, 2
        ORDER BY 1, 2
    '''
    name = 'registry_operations_by_registrar'
    stat_db = LOG_DB

