from stats_collector.stats import Statistics
from stats_collector import FRED_DB
from stats_collector.stats.stat_registry import stat_registry
from ..groups import FRED_DAILY_GROUP


@stat_registry.register(FRED_DAILY_GROUP)
class OtherObjectsTotal(Statistics):
    sql = '''
        SELECT
            'total',
            CASE type
                WHEN 1 THEN 'contact'
                WHEN 2 THEN 'nsset'
            END,
            COUNT(*)
        FROM
            object_registry O
        WHERE type in (1,2)
            AND (crdate < %(midnight)s AND (erdate IS NULL OR erdate >= %(midnight)s))
        GROUP BY type
    '''
    name = 'registry_other_objects'
    stat_db = FRED_DB

@stat_registry.register(FRED_DAILY_GROUP)
class OtherObjectsDeleted(Statistics):
    sql = '''
        SELECT
            'deleted',
            CASE type
                WHEN 1 THEN 'contact'
                WHEN 2 THEN 'nsset'
            END,
            COUNT(*) + CASE type
                WHEN 1 THEN 78548 --pocet smazanych kontaktu z dsd
                WHEN 2 THEN 0
            END
        FROM
            object_registry O
        WHERE type in (1,2)
            AND erdate < %(midnight)s
        GROUP BY type
    '''
    name = 'registry_other_objects'
    stat_db = FRED_DB

