from stats_collector.stats import Statistics
from stats_collector import FRED_DB
from stats_collector.stats.stat_registry import stat_registry
from ..groups import MOJEID_DAILY_GROUP


@stat_registry.register(MOJEID_DAILY_GROUP)
class MojeidContactsByVerificationLevel(Statistics):
    sql = '''
        SELECT
            eos.name, count(os.object_id)
          FROM
            object_state os
            JOIN enum_object_states eos ON eos.id = os.state_id
            JOIN object_state os2 ON os2.object_id = os.object_id
                AND os2.valid_from <= %(midnight)s
                AND (os2.valid_to IS NULL OR os2.valid_to > %(midnight)s)
            JOIN enum_object_states eos2 ON eos2.id = os2.state_id AND eos2.name = 'mojeidContact'
          WHERE
            eos.name IN ('conditionallyIdentifiedContact', 'identifiedContact', 'validatedContact')
            AND os.valid_from <= %(midnight)s
                AND (os.valid_to IS NULL OR os.valid_to > %(midnight)s)
          GROUP BY 1
          ORDER BY 1
    '''
    name = 'mojeid_contacts_by_verification_level'
    stat_db = FRED_DB

