from stats_collector.stats import Statistics
from stats_collector import LOG_DB
from stats_collector.stats.stat_registry import stat_registry
from ..groups import MOJEID_DAILY_GROUP


@stat_registry.register(MOJEID_DAILY_GROUP)
class MojeIDRequestCount(Statistics):
    sql = '''
        SELECT
            COUNT(*)
          FROM
            request r
            JOIN request_type rt ON rt.id = r.request_type_id
            JOIN result_code rc ON rc.id = r.result_code_id AND rc.service_id = r.service_id
          WHERE
            %(log_req_cond_mojeid)s
            AND rt.name = 'OpenIDRequest'
            AND rc.name = 'Success'
    '''
    name = 'mojeid_request_count'
    stat_db = LOG_DB
