class StatRegistry(object):

    def __init__(self):
        self.stats = set()
        self.groups = {}

    def register(self, stat_group_names=None):
        def inner(original_class):
            # register in common repository
            self.stats.add(original_class)
            # register in specified group
            if stat_group_names:
                if not isinstance(stat_group_names, list):
                    group_names = [stat_group_names]
                else:
                    group_names = stat_group_names
                for group_name in group_names:
                    group = self.groups.setdefault(group_name, [])
                    group.append(original_class)
            return original_class
        return inner


stat_registry = StatRegistry()
