import time
import types
from stats_collector import config

log_file = open(config.LOG_FILE, 'a')

def time_measure(func, *args, **kwd):
    ''' Function which calls and measures time of inner function/method
        and write result to log file and if DEBUG is True that to stdout, too.
    '''
    t1 = time.time()
    result = func(*args, **kwd)
    t_diff = time.time() - t1

    if isinstance(func, types.FunctionType):
        f_name = func.func_name
    else:
        f_name = '%s.%s' % (func.im_class.__name__, func.im_func.func_name)

    log_file.write('%-40s %10.3f\n' % (f_name + ':', t_diff))
    if config.DEBUG:
        print '%-40s %10.3f' % (f_name + ':', t_diff)

    return result
